' === BattMon20M2.bas ==============================
' This program runs on a PICAXE-20M2 processor.
' It monitors its own 3-cell, 4.5V battery supply.

' ==== Directives ====
  #com 3                    'specify serial port
  #picaxe 20M2              'specify processor
  #no_data                  'save time downloading
  #terminal 4800            'open terminal window

' ==== Constants =====
  symbol battPin = C.7      '3R voltage div. on C.7
  
' === Variables ======
 'Variables b0 through b4 are used in bintoascii
  symbol ADCval = w3
  symbol  battV = w4
	
' === Begin Main Program ===========================
dirsB = %11111111           'portB are all outputs
dirsC = %00111111           'pin C.7 is ADC input
adcconfig %011              'Vref+ = FVR, Vref- = 0V

do
  gosub getBattV
  sertxd (b3,".",b2,b1," Volts", CR,LF)
  sleep 3                   'sleep about 7 seconds
loop

' === End Main Program - Subroutines Follow ========
getBattV:
  fvrsetup FVR2048          'set FVR at 2048mV
  readadc10 battPin, ADCval 'get raw data
  battV = 2 * ADCval        'for FVR = 2048mV
  battV = 3 * battV         'for three-cell battery 
  if b0 >= 5 then           'round-off to hundredths
    inc b1
  endif
  bintoascii battV,b4,b3,b2,b1,b0
  return