' === Test9700A ===========================================
' This program tests the MCP9700A linear active thermistor.
' The program is adapted from the one presented by Svejk,
' in "PICAXE-08M2 Temperature Sensing with MCP9700/9700A."

' === Directives ===
  #com 6                      'specify serial port
  #picaxe 20M2                'specify processor
  #terminal 4800              'open the terminal window
  #no_data                    'save time downloading
  
' === Constants ======
  symbol pwr9700 = C.0        'MCP9700A V+ connected to C.0
  symbol  sensor = C.1        'temperature ADC channel

' === Variables ======
  symbol  ADCval = w0         'stores raw temperature data

' === Begin Main Program ==================================
  dirsB = %11111111           'portB all outputs
  dirsc = %10111101           'pin C.1 ADC input

do
  high pwr9700                'power up MCP9700A
  pause 10                    'startup delay
  readadc10 sensor,ADCval     'fetch raw data
  low pwr9700                 'turn off MCP9700A
  sertxd (#ADCval,CR,LF)      'display data
  wait 1                      'slow it down a bit
loop